/*
 * bitchx.c - all the ctcp handling (except DCC, it's special ;)
 * this is an eggdrop-specific ctcp module, for emulation of another client
 * get a client-specific module
 */

#define MAKING_WOOBIE
#define MODULE_NAME "bitchx"
#include "../../config.h"
#ifdef HAVE_UNAME
#include <sys/utsname.h>
#endif
#include "../../main.h"
#include "../server.mod/server.h"
#include <netinet/in.h>
#include <arpa/inet.h>

static struct modcall_server * SERVER =NULL;
static ModuleEntry ME;
static struct version bitchx_ver = { 2, 0, 0, 0 };
static struct version required_server = { 2, 0, 0, 0 };
static struct patches bitchx_patches[] = {
#include "patch.h"
};

static char ctcp_version[256];
static char ctcp_finger[256];
static char ctcp_userinfo[256];

int idle_time = 0;
        void update_idle_time () {
        if ((random() & 0xff00) == 0)
        idle_time = 0;
        else
        idle_time++;
       }


static void * ctcp_FINGER (void ** args, char * UNUSED(mask)) {

    if (ctcp_finger[0]) 
     SERVER->ctcp_reply_len += G->sprintf(SERVER->ctcp_reply + 
					  SERVER->ctcp_reply_len,
                                          511 - SERVER->ctcp_reply_len,
"\001FINGER (%s) Idle %d seconds\001", SERVER->botuserhost, idle_time);
   return BIND_NOMATCH;
}

static void * ctcp_ECHOPINGERR (void ** args, char * UNUSED(mask)) {
   context;
     if (strlen((char *)args[6]) <= 80) /* bitch ignores > 80 */
     SERVER->ctcp_reply_len += G->sprintf(SERVER->ctcp_reply +
					  SERVER->ctcp_reply_len,
					  511 - SERVER->ctcp_reply_len,
					  "\001%s %s\001",
					  args[5],args[6]);
   return BIND_NOMATCH;
}

static void * ctcp_VERSION (void ** UNUSED(args), char * UNUSED(mask)) 
{
        char * ver_t, * uni_x; 
 #ifdef HAVE_UNAME
        struct utsname un;
        if (uname(&un) < 0)
       {
          ver_t = ctcp_version;
          uni_x = "unknown";
       }
       else
         {
                 ver_t = un.release;
                 uni_x = un.sysname;
         }
#else
        ver_t = ctcp_version;
        uni_x = "unknown";
#endif
  if (ctcp_version[0]) 
     SERVER->ctcp_reply_len += G->sprintf(SERVER->ctcp_reply + 
					  SERVER->ctcp_reply_len,
					  511 - SERVER->ctcp_reply_len,
"\001VERSION \002BitchX-74p2+Tcl1.3g\002 by panasync \002-\002 %s %s : \002Keep it to yourself!\002\001", uni_x, ver_t);

   return BIND_NOMATCH;
}

static void * ctcp_USERINFO (void ** UNUSED(args), char * UNUSED(mask)) {
   context;
   if (ctcp_userinfo[0]) 
     SERVER->ctcp_reply_len += G->sprintf(SERVER->ctcp_reply + 
					  SERVER->ctcp_reply_len,
					  511 - SERVER->ctcp_reply_len,
"\001USERINFO \001");
   return BIND_NOMATCH;
}

static void * ctcp_CLIENTINFO (void ** args, char * UNUSED(mask)) {
   int p;
   char * par = (char *)args[6];
   context;
   if (!par[0])
     p = 0x001;
   else if (!strcasecmp(par, "version"))
     p = 0x002;
   else if (!strcasecmp(par, "clientinfo"))
     p = 0x003;
   else if (!strcasecmp(par, "userinfo"))
     p = 0x004;
   else if (!strcasecmp(par, "errmsg"))
     p = 0x005;
   else if (!strcasecmp(par, "finger"))
     p = 0x006;
   else if (!strcasecmp(par, "time"))
     p = 0x007;
   else if (!strcasecmp(par, "action"))
     p = 0x008;
   else if (!strcasecmp(par, "dcc"))
     p = 0x009;
   else if (!strcasecmp(par, "ping"))
     p = 0x00A;
   else if (!strcasecmp(par, "echo"))
     p = 0x00B;
   else if (!strcasecmp(par, "sed"))
     p = 0x00D;
   else if (!strcasecmp(par, "utc"))
     p = 0x023;
   else if (!strcasecmp(par, "cdcc"))
     p = 0x010;
   else if (!strcasecmp(par, "bdcc"))
     p = 0x011;
   else if (!strcasecmp(par, "xdcc"))
     p = 0x012;
   else if (!strcasecmp(par, "invite"))
     p = 0x013;
   else if (!strcasecmp(par, "whoami"))
     p = 0x014;
   else if (!strcasecmp(par, "op"))
     p = 0x015;
   else if (!strcasecmp(par, "ops"))
     p = 0x016;
   else if (!strcasecmp(par, "xlink"))
     p = 0x017;
   else if (!strcasecmp(par, "xmit"))
     p = 0x018;
   else if (!strcasecmp(par, "uptime"))
     p = 0x019;
  else if (!strcasecmp(par, "unban"))
     p = 0x020;
  else if (!strcasecmp(par, "ident"))
     p = 0x021;
   else
     p = 0x022;
   SERVER->ctcp_reply_len += G->sprintf (SERVER->ctcp_reply + 
					 SERVER->ctcp_reply_len,
					 511 - SERVER->ctcp_reply_len, 
					 "\001%s %s\001",
					 (p == 0x022) ? "ERRMSG" :
					 "CLIENTINFO",
					 G->lang(ME, p, "s", par));
   return BIND_NOMATCH;
}

static void * ctcp_TIME (void ** UNUSED(args), char * UNUSED(mask)) {
   char tms[81];
   
   context;
   strcpy(tms, ctime(&G->now));
   tms[strlen(tms) - 1] = 0;
   SERVER->ctcp_reply_len += G->sprintf(SERVER->ctcp_reply + 
					SERVER->ctcp_reply_len, 
					511 - SERVER->ctcp_reply_len,
					"\001TIME %s\001", tms);
   return BIND_NOMATCH;
}

static void * ctcp_CHAT (void ** args, char * mask) {
   struct userrec * u = (struct userrec *)args[3];
   int atr = u ? u->flags : 0;
   Socket * ptr = G->socklist;
   char buf[512];
   
   context;
   if ((atr & (USER_PARTY | USER_XFER)) ||
       ((atr & USER_OP) && !G->require_p)) {
      while ((ptr = ptr->Next()))
	 if ((ptr->Type()->flags & DCT_LISTEN) &&
	     (!strcmp(ptr->Nick(), "(telnet)") || 
	      !strcmp(ptr->Nick(), "(users)"))) {
	    int addr;      
	    
	    addr = G->natip[0] ? inet_addr(G->natip) : G->getmyip().s_addr;
	    G->sprintf(buf, 511, "\001DCC CHAT chat %lu %u\001\n",
		       iptolong(addr), ptr->LocalPort());
	    SERVER->send_msg(Q_SERVER, (char *)args[1], buf);
	    break;
	 }
      if (!ptr)
	SERVER->ctcp_reply_len += G->sprintf (SERVER->ctcp_reply + 
					      SERVER->ctcp_reply_len, 
					      511 - SERVER->ctcp_reply_len,
					      "\001%s\001",
					      G->lang(ME, 0x00E, ""));
   }
   return BIND_NOMATCH;
}

#define COMMANDS 9
static command_binds myctcp[COMMANDS] = {
     { "FINGER", "", ctcp_FINGER, NULL },
     { "ECHO", "", ctcp_ECHOPINGERR, NULL },
     { "PING", "", ctcp_ECHOPINGERR, NULL },
     { "ERRMSG", "", ctcp_ECHOPINGERR, NULL },
     { "VERSION", "", ctcp_VERSION, NULL },
     { "USERINFO", "", ctcp_USERINFO, NULL },
     { "CLIENTINFO", "", ctcp_CLIENTINFO, NULL },
     { "TIME", "", ctcp_TIME, NULL },
     { "CHAT", "", ctcp_CHAT, NULL },
};

static tcl_strings mystrings [] = {
     {"ctcp-version", ctcp_version, 120, 0},
     {"ctcp-finger", ctcp_finger, 120, 0},
     {"ctcp-userinfo", ctcp_userinfo, 120, 0},
     {0, 0, 0, 0}
};

static char *bitchx_close(char * UNUSED(who)) {
   G->rem_tcl_strings(mystrings);
   SERVER->bt_ctcp->RemBinds(myctcp,COMMANDS);
   G->del_hook( HOOK_SECONDLY, update_idle_time);
   G->rem_help_reference("ctcp.help");
   G->module_undepend(ME);
   return NULL;
}

extern "C" {
char *bitchx_start (void *);
};

static struct modcall BITCHX = {
   bitchx_start, bitchx_close, 0
};

char *bitchx_start (void * global_funcs) {
   G = (struct modcall_eggdrop *)global_funcs;
   context;
   ME = G->module_register(MODULE_NAME, &BITCHX, &bitchx_ver, bitchx_patches);
   if (!(SERVER = (struct modcall_server *)
      G->module_depend(ME, "server", &required_server)))
     return "You need the server module to use the bitchx module.";
   G->add_tcl_strings(mystrings);
   SERVER->bt_ctcp->AddBinds(myctcp, COMMANDS);
   G->add_hook( HOOK_SECONDLY, update_idle_time);
   G->add_help_reference("ctcp.help");
   G->loadlanguage(MODULE_NAME);
   if (!ctcp_version[0]) {
      strncpy(ctcp_version, G->ver, 160);
      ctcp_version[160] = 0;
   }
   if (!ctcp_finger[0]) {
      strncpy(ctcp_finger, G->ver, 160);
      ctcp_finger[160] = 0;
   }
   if (!ctcp_userinfo[0]) {
      strncpy(ctcp_userinfo, G->ver, 160);
      ctcp_userinfo[160] = 0;
   }
   return NULL;
}
